#/bin/sh

for Dev in \
	TITAN K20c K20Xm 750 980
do
for SYMV in \
	DSYMVU DSYMVL SSYMVU SSYMVL
do

	OUTPUT=plot_data_"$Dev"_"$SYMV"

	ls *$SYMV*$Dev* | \
	awk '\
		BEGIN{ \
			D="'$Dev'"; \
			K="'$SYMV'"; \
			if ( D == "580"   ) DEV="GeForce GTX580"; \
			if ( D == "750"   ) DEV="GeForce GTX750Ti"; \
			if ( D == "980"   ) DEV="GeForce GTX980"; \
			if ( D == "TITAN" ) DEV="GeForce TitanBlack"; \
			if ( D == "K20c"  ) DEV="Tesla K20c"; \
			if ( D == "K20Xm" ) DEV="Tesla K20Xm"; \
			printf( "set key bottom\n" ); \
			printf( "set grid\n" ); \
			printf( "set pointsize 0.3\n" ); \
			printf( "set title \""K" on a <"DEV">\"\n" ); \
			printf( "set xlabel \"[dimension]\"\n" ); \
			printf( "set ylabel \"[GFLOPS]\"\n" ); \
			PLOT = "plot "; \
			c=" "; \
		} \
		{ \
			PLOT = PLOT c "\"" $1 "\" u 2:5 t \"" $1 "\""; \
			c=","; \
		} \
		END{ \
			printf( "set term post eps color\n" ); \
			printf( "set output \"'$OUTPUT'.eps\"\n" ); \
			print PLOT; \
			printf( "set term png\n" ); \
			printf( "set output \"'$OUTPUT'.png\"\n" ); \
			print PLOT; \
			printf( "quit\n" ); \
		} \
	' | gnuplot

done
done


