#if !defined(TYPE_DOUBLE)
# define TYPE_DOUBLE 1
#endif

#if TYPE_DOUBLE==1
#   define __isDOUBLE__         1
#   define __isFLOAT__          0
#   define EPS			(1.7764e-15)
#endif
#if TYPE_DOUBLE==0
#   define __isDOUBLE__         0
#   define __isFLOAT__          1
#   define EPS			(1.1921e-07)
#endif

double get_wtime(void);
int do_usleep(int usec);
int get_gpu_id(void);
void print_head(char *func_name);

void
ASPEN_init( int );

void
ASPEN_shutdown( void );

int
ASPEN_get_driver_Version( void );

int
ASPEN_get_runtime_Version( void );

void
ASPEN_SGEMV_t(int blk, float alpha, float beta, float *dA, float *dB,
	      float *dC,
	      int LDA,
	      int N1, int N2);
void
ASPEN_SGEMV_n(int blk, float alpha, float beta, float *dA, float *dB,
	      float *dC,
	      int LDA,
	      int N1, int N2);
void
ASPEN_SSYMVu(int blk, int N, float *dA, int LDA, float *dB,
	     float *dC,
	     float alpha, float beta);

void
ASPEN_SSYMVl(int blk, int N, float *dA, int LDA, float *dB,
	     float *dC,
	     float alpha, float beta);

void
ASPEN_DGEMV_t(int blk, double alpha, double beta, double *dA, double *dB,
	      double *dC,
	      int LDA,
	      int N1, int N2);
void
ASPEN_DGEMV_n(int blk, double alpha, double beta, double *dA, double *dB,
	      double *dC,
	      int LDA,
	      int N1, int N2);
void
ASPEN_DSYMVu(int blk, int N, double *dA, int LDA, double *dB,
	     double *dC,
	     double alpha, double beta);
void
ASPEN_DSYMVl(int blk, int N, double *dA, int LDA, double *dB,
	     double *dC,
	     double alpha, double beta);


enum S_FUNCS { SGEMV_N, SGEMV_T, SSYMV_U, SSYMV_L };
enum D_FUNCS { DGEMV_N, DGEMV_T, DSYMV_U, DSYMV_L };

