#ifndef	ASPEN_H_INCLUDED

#include "aspen_version.h"


#ifdef __cplusplus
extern "C" {
#endif
  
  
  /* User must call ASPEN_init for initialization */
  int
  ASPEN_init ( int device_id );
  
  /* User must finalize the ASPEN library by ASPEN_shutdown */
  int
  ASPEN_shutdown ( void );
  
  
  void
  ASPEN_dsymv ( char uplo, int n,
                double alpha, 
                double * a, int lda,
                double * x, int incx,
                double beta,  
                double * y, int incy );
  
  void
  ASPEN_ssymv ( char uplo, int n,
                float alpha, 
                float * a, int lda,
                float * x, int incx,
                float beta,  
                float * y, int incy );
  
#if 0
  void
  ASPEN_zhemv ( char uplo, int n,
                cuDoubleComplex alpha, 
                cuDoubleComplex * a, int lda,
                cuDoubleComplex * x, int incx,
                cuDoubleComplex beta,  
                cuDoubleComplex * y, int incy );
  
  void
  ASPEN_chemv ( char uplo, int n,
                cuFloatComplex alpha, 
                cuFloatComplex * a, int lda,
                cuFloatComplex * x, int incx,
                cuFloatComplex beta,  
                cuFloatComplex * y, int incy );
#endif
  
  void
  ASPEN_dgemv ( char trans, int m, int n,
                double alpha, 
                double * a, int lda,
                double * x, int incx,
                double beta,  
                double * y, int incy );
  
  void
  ASPEN_sgemv ( char trans, int m, int n,
                float alpha, 
                float * a, int lda,
                float * x, int incx,
                float beta,  
                float * y, int incy );
#if 0
  void
  ASPEN_zgemv ( char trans, int n,
                cuDoubleComplex alpha, 
                cuDoubleComplex * a, int lda,
                cuDoubleComplex * x, int incx,
                cuDoubleComplex beta,  
                cuDoubleComplex * y, int incy );
  
  void
  ASPEN_cgemv ( char trans, int n,
                cuFloatComplex alpha, 
                cuFloatComplex * a, int lda,
                cuFloatComplex * x, int incx,
                cuFloatComplex beta,  
                cuFloatComplex * y, int incy );
#endif
  

  void
  ASPEN_daxpy ( int n,
                double alpha,
                double * x, int incx,
                double * y, int incy );
  void
  ASPEN_saxpy ( int n,
                float alpha,
                float * x, int incx,
                float * y, int incy );
  void
  ASPEN_zaxpy ( int n,
                cuDoubleComplex alpha,
                cuDoubleComplex * x, int incx,
                cuDoubleComplex * y, int incy );
  void
  ASPEN_caxpy ( int n,
                cuFloatComplex alpha,
                cuFloatComplex * x, int incx,
                cuFloatComplex * y, int incy );
  

  void
  ASPEN_dswap ( int n,
                double * x, int incx,
                double * y, int incy );
  void
  ASPEN_sswap ( int n,
                float * x, int incx,
                float * y, int incy );
  void
  ASPEN_zswap ( int n,
                cuDoubleComplex * x, int incx,
                cuDoubleComplex * y, int incy );
  void
  ASPEN_cswap ( int n,
                cuFloatComplex * x, int incx,
                cuFloatComplex * y, int incy );
  

  void
  ASPEN_dcopy ( int n,
                double * x, int incx,
                double * y, int incy );
  void
  ASPEN_scopy ( int n,
                float * x, int incx,
                float * y, int incy );
  void
  ASPEN_zcopy ( int n,
                cuDoubleComplex * x, int incx,
                cuDoubleComplex * y, int incy );
  void
  ASPEN_ccopy ( int n,
                cuFloatComplex * x, int incx,
                cuFloatComplex * y, int incy );


  void
  ASPEN_dscal ( int n,
                double alpha, double * x, int incx );
  void
  ASPEN_sscal ( int n,
                float alpha, float * x, int incx );
  void
  ASPEN_zscal ( int n,
                cuDoubleComplex alpha, cuDoubleComplex * x, int incx );
  void
  ASPEN_cscal ( int n,
                cuFloatComplex alpha, cuFloatComplex * x, int incx );
  

#ifdef __cplusplus
}
#endif

#define	ASPEN_H_INCLUDED	1
#endif

