#ifndef ASPEN_COMPLEX_H_INCLUDED

#include <cuComplex.h>

__host__ __device__ __forceinline__
float Conj ( const float v ) {
  return (v);
}

__host__ __device__ __forceinline__
double Conj ( const double v ) {
  return (v);
}

__host__ __device__ __forceinline__ cuFloatComplex
make_Complex ( cuFloatComplex x ) {
  return x;
}
__host__ __device__ __forceinline__ cuFloatComplex
make_Complex ( float x, float y ) {
  return make_cuFloatComplex ( x, y );
}

__host__ __device__ __forceinline__ cuFloatComplex
make_Complex ( float x ) {
  return make_cuFloatComplex ( x, (float)0 );
}

__host__ __device__ __forceinline__ cuDoubleComplex
make_Complex ( cuDoubleComplex x ) {
  return x;
}
__host__ __device__ __forceinline__ cuDoubleComplex
make_Complex ( double x, double y ) {
  return make_cuDoubleComplex ( x, y );
}

__host__ __device__ __forceinline__ cuDoubleComplex
make_Complex ( double x ) {
  return make_cuDoubleComplex ( x, (double)0 );
}

/*********************************************************************
 * cuFloatComplex
 *********************************************************************/


__host__ __device__ __forceinline__ bool operator== (const cuFloatComplex a, const cuFloatComplex b) {
  if ((a.x == b.x) && (a.y == b.y))
    return true;
  else
    return false;
}

__host__ __device__ __forceinline__ bool operator!= (const cuFloatComplex a, const cuFloatComplex b) {
  if ((a.x != b.x) || (a.y != b.y))
    return true;
  else
    return false;
}

__host__ __device__ __forceinline__ bool operator&& (const cuFloatComplex a, const cuFloatComplex b) {
  if ((a.x && b.x) && (a.y && b.y))
    return true;
  else
    return false;
}

__host__ __device__ __forceinline__ cuFloatComplex operator+ (cuFloatComplex a, cuFloatComplex b){
  return cuCaddf (a, b);
}

__host__ __device__ __forceinline__ void operator+= (cuFloatComplex &a, const cuFloatComplex b) {
  a = cuCaddf (a, b);
}

__host__ __device__ __forceinline__ cuFloatComplex operator- (cuFloatComplex a, cuFloatComplex b){
  return cuCsubf (a, b);
}

__host__ __device__ __forceinline__ void operator-= (cuFloatComplex &a, const cuFloatComplex b) {
  a = cuCsubf (a, b);
}

__host__ __device__ __forceinline__ cuFloatComplex operator* (cuFloatComplex a, cuFloatComplex b){
  return cuCmulf (a, b);
}

__host__ __device__ __forceinline__ void operator*= (cuFloatComplex &a, const cuFloatComplex b) {
  a = cuCmulf (a, b);
}

__host__ __device__ __forceinline__ cuFloatComplex Conj (const cuFloatComplex v) {
  return cuConjf (v);
}

__host__ __device__ __forceinline__ cuFloatComplex ImZero (const cuFloatComplex v) {
  return make_cuFloatComplex (v.x, 0.);
}


/*********************************************************************
 * cuDoubleComplex
 *********************************************************************/

__host__ __device__ __forceinline__ bool operator== (const cuDoubleComplex a, const cuDoubleComplex b) {
  if ((a.x == b.x) && (a.y == b.y))
    return true;
  else
    return false;
}

__host__ __device__ __forceinline__ bool operator!= (const cuDoubleComplex a, const cuDoubleComplex b) {
  if ((a.x != b.x) || (a.y != b.y))
    return true;
  else
    return false;
}

__host__ __device__ __forceinline__ bool operator&& (const cuDoubleComplex a, const cuDoubleComplex b) {
  if ((a.x && b.x) && (a.y && b.y))
    return true;
  else
    return false;
}

__host__ __device__ __forceinline__ cuDoubleComplex operator+ (cuDoubleComplex a, cuDoubleComplex b) {
  return cuCadd (a, b);
}

__host__ __device__ __forceinline__ void operator+= (cuDoubleComplex &a, const cuDoubleComplex b) {
  a = cuCadd (a, b);
}

__host__ __device__ __forceinline__ cuDoubleComplex operator- (cuDoubleComplex a, cuDoubleComplex b) {
  return cuCsub (a, b);
}

__host__ __device__ __forceinline__ void operator-= (cuDoubleComplex &a, const cuDoubleComplex b) {
  a = cuCsub (a, b);
}

__host__ __device__ __forceinline__ cuDoubleComplex operator* (cuDoubleComplex a, cuDoubleComplex b) {
  return cuCmul (a, b);
}

__host__ __device__ __forceinline__ void operator*= (cuDoubleComplex &a, const cuDoubleComplex b) {
  a = cuCmul (a, b);
}

__host__ __device__ __forceinline__ cuDoubleComplex Conj (const cuDoubleComplex v) {
  return cuConj (v);
}

__host__ __device__ __forceinline__ cuDoubleComplex ImZero (const cuDoubleComplex v) {
  return make_cuDoubleComplex (v.x, 0.);
}

#define ASPEN_COMPLEX_H_INCLUDED	1
#endif

