#ifndef ASPEN_MAKE_CONST_H_INCLUDED

#include "aspen_complex.h"

template < class TYPE >
__forceinline__ __host__ __device__ TYPE
makeCONST ( const int x )
{
  return (TYPE)(x);
}

template < >
__forceinline__ __host__ __device__ cuDoubleComplex
makeCONST < cuDoubleComplex > ( const int x )
{
  return make_Complex ( (double)(x) );
}

template < >
__forceinline__ __host__ __device__ cuFloatComplex
makeCONST < cuFloatComplex > ( const int x )
{
  return make_Complex ( (float)(x) );
}

template < class TYPE >
__forceinline__ __host__ __device__ TYPE
makeCONST ( const float x )
{
  return (TYPE)(x);
}

template < >
__forceinline__ __host__ __device__ cuDoubleComplex
makeCONST < cuDoubleComplex > ( const float x )
{
  return make_Complex ( (double)(x) );
}

template < >
__forceinline__ __host__ __device__ cuFloatComplex
makeCONST < cuFloatComplex > ( const float x )
{
  return make_Complex ( (float)(x) );
}

template < class TYPE >
__forceinline__ __host__ __device__ TYPE
makeCONST ( const double x )
{
  return (TYPE)(x);
}

template < >
__forceinline__ __host__ __device__ cuDoubleComplex
makeCONST < cuDoubleComplex > ( const double x )
{
  return make_Complex ( (double)(x) );
}

template < >
__forceinline__ __host__ __device__ cuFloatComplex
makeCONST < cuFloatComplex > ( const double x )
{
  return make_Complex ( (float)(x) );
}

#define ASPEN_MAKE_CONST_H_INCLUDED	1
#endif

