#ifndef ASPEN_LDST_H_INCLUDED

__forceinline__
__device__ double Load_Global ( double *addr__ )
{
  double  s;
  asm volatile ( "ld.global.f64\t%0, [%1];" : "=d"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ float Load_Global ( float *addr__ )
{
  float  s;
  asm volatile ( "ld.global.f32\t%0, [%1];" : "=f"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ cuDoubleComplex Load_Global ( cuDoubleComplex *addr__ )
{
  double  sx,sy;
  asm volatile ( "ld.global.f32\t%0, [%1];" : "=d"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.f32\t%0, [%1];" : "=d"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ cuFloatComplex Load_Global ( cuFloatComplex *addr__ )
{
  float  sx,sy;
  asm volatile ( "ld.global.f32\t%0, [%1];" : "=f"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.f32\t%0, [%1];" : "=f"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ double Load_Global_CG ( double *addr__ )
{
  double  s;
  asm volatile ( "ld.global.cg.f64\t%0, [%1];" : "=d"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ float Load_Global_CG ( float *addr__ )
{
  float  s;
  asm volatile ( "ld.global.cg.f32\t%0, [%1];" : "=f"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ cuDoubleComplex Load_Global_CG ( cuDoubleComplex *addr__ )
{
  double  sx,sy;
  asm volatile ( "ld.global.cg.f64\t%0, [%1];" : "=d"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.cg.f64\t%0, [%1];" : "=d"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ cuFloatComplex Load_Global_CG ( cuFloatComplex *addr__ )
{
  float  sx,sy;
  asm volatile ( "ld.global.cg.f32\t%0, [%1];" : "=f"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.cg.f32\t%0, [%1];" : "=f"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}


__forceinline__
__device__ double Load_Global_CS ( double *addr__ )
{
  double  s;
  asm volatile ( "ld.global.cs.f64\t%0, [%1];" : "=d"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ float Load_Global_CS ( float *addr__ )
{
  float  s;
  asm volatile ( "ld.global.cs.f32\t%0, [%1];" : "=f"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ cuDoubleComplex Load_Global_CS ( cuDoubleComplex *addr__ )
{
  double  sx,sy;
  asm volatile ( "ld.global.cs.f64\t%0, [%1];" : "=d"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.cs.f64\t%0, [%1];" : "=d"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ cuFloatComplex Load_Global_CS ( cuFloatComplex *addr__ )
{
  float  sx,sy;
  asm volatile ( "ld.global.cs.f32\t%0, [%1];" : "=f"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.cs.f32\t%0, [%1];" : "=f"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ double Load_Global_CV ( double *addr__ )
{
  double  s;
  asm volatile ( "ld.global.cv.f64\t%0, [%1];" : "=d"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ float Load_Global_CV ( float *addr__ )
{
  float  s;
  asm volatile ( "ld.global.cv.f32\t%0, [%1];" : "=f"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ cuDoubleComplex Load_Global_CV ( cuDoubleComplex *addr__ )
{
  double  sx,sy;
  asm volatile ( "ld.global.cv.f64\t%0, [%1];" : "=d"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.cv.f64\t%0, [%1];" : "=d"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ cuFloatComplex Load_Global_CV ( cuFloatComplex *addr__ )
{
  float  sx,sy;
  asm volatile ( "ld.global.cv.f32\t%0, [%1];" : "=f"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.global.cv.f32\t%0, [%1];" : "=f"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ double Load_Volatile_Global ( double *addr__ )
{
  double  s;
  asm volatile ( "ld.volatile.global.f64\t%0, [%1];" : "=d"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ float Load_Volatile_Global ( float *addr__ )
{
  float  s;
  asm volatile ( "ld.volatile.global.f32\t%0, [%1];" : "=f"(s) : "l"(addr__) );
  return s;
}

__forceinline__
__device__ cuDoubleComplex Load_Volatile_Global ( cuDoubleComplex *addr__ )
{
  double  sx,sy;
  asm volatile ( "ld.volatile.global.f64\t%0, [%1];" : "=d"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.volatile.global.f64\t%0, [%1];" : "=d"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}

__forceinline__
__device__ cuFloatComplex Load_Volatile_Global ( cuFloatComplex *addr__ )
{
  float  sx,sy;
  asm volatile ( "ld.volatile.global.f32\t%0, [%1];" : "=f"(sx) : "l"(&addr__->x) );
  asm volatile ( "ld.volatile.global.f32\t%0, [%1];" : "=f"(sy) : "l"(&addr__->y) );
  return make_Complex ( sx, sy );
}


__forceinline__
__device__ void Store_Global ( double *addr__, const double s )
{
  asm volatile ( "st.global.f64\t[%1], %0;" : : "d"(s), "l"(addr__) );
}

__forceinline__
__device__ void Store_Global ( float *addr__, const float s )
{
  asm volatile ( "st.global.f32\t[%1], %0;" : : "f"(s), "l"(addr__) );
}

__forceinline__
__device__ void Store_Global ( cuDoubleComplex *addr__, const cuDoubleComplex s )
{
  asm volatile ( "st.global.f64\t[%1], %0;" : : "d"(s.x), "l"(&addr__->x) );
  asm volatile ( "st.global.f64\t[%1], %0;" : : "d"(s.y), "l"(&addr__->y) );
}

__forceinline__
__device__ void Store_Global ( cuFloatComplex *addr__, const cuFloatComplex s )
{
  asm volatile ( "st.global.f32\t[%1], %0;" : : "f"(s.x), "l"(&addr__->x) );
  asm volatile ( "st.global.f32\t[%1], %0;" : : "f"(s.y), "l"(&addr__->y) );
}

__forceinline__
__device__ void Store_Global_CG ( double *addr__, const double s )
{
  asm volatile ( "st.global.cg.f64\t[%1], %0;" : : "d"(s), "l"(addr__) );
}

__forceinline__
__device__ void Store_Global_CG ( float *addr__, const float s )
{
  asm volatile ( "st.global.cg.f32\t[%1], %0;" : : "f"(s), "l"(addr__) );
}

__forceinline__
__device__ void Store_Global_CG ( cuDoubleComplex *addr__, const cuDoubleComplex s )
{
  asm volatile ( "st.global.cg.f64\t[%1], %0;" : : "d"(s.x), "l"(&addr__->x) );
  asm volatile ( "st.global.cg.f64\t[%1], %0;" : : "d"(s.y), "l"(&addr__->y) );
}

__forceinline__
__device__ void Store_Global_CG ( cuFloatComplex *addr__, const cuFloatComplex s )
{
  asm volatile ( "st.global.cg.f32\t[%1], %0;" : : "f"(s.x), "l"(&addr__->x) );
  asm volatile ( "st.global.cg.f32\t[%1], %0;" : : "f"(s.y), "l"(&addr__->y) );
}

__forceinline__
__device__ void Store_Volatile_Global ( double *addr__, const double s )
{
  asm volatile ( "st.volatile.global.f64\t[%1], %0;" : : "d"(s), "l"(addr__) );
}

__forceinline__
__device__ void Store_Volatile_Global ( float *addr__, const float s )
{
  asm volatile ( "st.volatile.global.f32\t[%1], %0;" : : "f"(s), "l"(addr__) );
}

__forceinline__
__device__ void Store_Volatile_Global ( cuDoubleComplex *addr__, const cuDoubleComplex s )
{
  asm volatile ( "st.volatile.global.f64\t[%1], %0;" : : "d"(s.x), "l"(&addr__->x) );
  asm volatile ( "st.volatile.global.f64\t[%1], %0;" : : "d"(s.y), "l"(&addr__->y) );
}

__forceinline__
__device__ void Store_Volatile_Global ( cuFloatComplex *addr__, const cuFloatComplex s )
{
  asm volatile ( "st.volatile.global.f32\t[%1], %0;" : : "f"(s.x), "l"(&addr__->x) );
  asm volatile ( "st.volatile.global.f32\t[%1], %0;" : : "f"(s.y), "l"(&addr__->y) );
}



__forceinline__
__device__ void * convert_addr_to_global ( const void * addr__ )
{
  unsigned long long int  global_addr;
  asm volatile ( "cvta.to.global.u64\t%0, %1;"
                 : "=l"(global_addr) : "l"(addr__) );
  return (void *)global_addr;
}

__forceinline__
__device__ void prefetch_L1 (  void *addr__ )
{
  const unsigned long  addr = (unsigned long) addr__;
  asm volatile ( "prefetch.global.L1\t[%0];"
                 : : "l"(addr) );
}

__forceinline__
__device__ void prefetch_L2 (  void *addr__ )
{
  const unsigned long  addr = (unsigned long) addr__;
  asm volatile ( "prefetch.global.L2\t[%0];"
                 : : "l"(addr) );
}

#define ASPEN_LDST_H_INCLUDED		1
#endif

