#include "float.h"
#include "aspen_devel.h"


extern "C" void
API(ssymv) ( char uplo, int n,
	     scalar_t alpha,
	     scalar_t * a, int lda,
	     scalar_t * x, int incx,
	     scalar_t beta,
	     scalar_t * y, int incy )
{
  if ( n <= 0 ) return;
  if ( alpha == makeCONST<float>(0) && beta == makeCONST<float>(1) ) return;
  int     upper = (uplo=='U')||(uplo=='u');
  int     lower = (uplo=='L')||(uplo=='l');
  if ( upper && incx == 1 && incy == 1 ) {
    API(SSYMVu) ( -1, n, a, lda, x, y, alpha, beta );
  } else if ( lower && incx == 1 && incy == 1 ) {
    API(SSYMVl) ( -1, n, a, lda, x, y, alpha, beta );
  } else {
    cublasSsymv ( uplo, n, alpha, a, lda, x, incx, beta, y, incy );
  }
}

