#include "../tuning/CURRENT_GPU"

#include "float.h"
#include "aspen_devel.h"


extern "C" void
API(SSYMVl) ( const int blk,
              const int n, const scalar_t * a, const int lda,
              const scalar_t * x, scalar_t * y,
              const scalar_t alpha, const scalar_t beta )
{

  // y = alpha * A * x + beta * y
  // y(1:n1)
  // x(1:n2)

  if ( n <= 0 ) return;
  if ( alpha == makeCONST<float>(0) && beta == makeCONST<float>(1) ) return;

  int Ver = API(get_device_CC) ( );

  if ( CURRENT_GPU == Ver ) {
    ASPEN_tuned_kernel_name(SSYMVl) ( blk,
                                      n, a, lda, x, y, alpha, beta );
  } else {
    ; /* unmatched */
  }

}

