#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
Sun Mar 13 11:48:46 JST 2016
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;


#define	KERNEL_17	1
#define	KERNEL_4	1
#define	KERNEL_18	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_10	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_14	1
#define	KERNEL_1	1
#define	KERNEL_15	1
#define	KERNEL_2	1
#define	KERNEL_16	1
#define	KERNEL_3	1

if ( n >= 1 && n < 3 ) {
	BLK = 14;
} else
if ( n >= 3 && n < 448 ) {
	BLK = 12;
} else
if ( n >= 448 && n < 900 ) {
	BLK = 18;
} else
if ( n >= 900 && n < 1080 ) {
	BLK = 16;
} else
if ( n >= 1080 && n < 1116 ) {
	BLK = 17;
} else
if ( n >= 1116 && n < 1373 ) {
	BLK = 3;
} else
if ( n >= 1373 && n < 1620 ) {
	BLK = 4;
} else
if ( n >= 1620 && n < 1920 ) {
	BLK = 8;
} else
if ( n >= 1920 && n < 2102 ) {
	BLK = 15;
} else
if ( n >= 2102 && n < 2700 ) {
	BLK = 9;
} else
if ( n >= 2700 && n < 2940 ) {
	BLK = 2;
} else
if ( n >= 2940 && n < 3000 ) {
	BLK = 5;
} else
if ( n >= 3000 && n < 3150 ) {
	BLK = 10;
} else
if ( n >= 3150 && n < 4410 ) {
	BLK = 19;
} else
if ( n >= 4410 && n < 4530 ) {
	BLK = 0;
} else
if ( n >= 4530 && n < 4620 ) {
	BLK = 19;
} else
if ( n >= 4620 && n < 7457 ) {
	BLK = 0;
} else
if ( n >= 7457 && n < 26955 ) {
	BLK = 1;
} else
if ( n >= 26955 && n < 100000000 ) {
	BLK = 1;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 32 , 7 , 7, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 64 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 64 , 3 , 6, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 32 , 10 , 5, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 32 , 5 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 32 , 7 , 8, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 32 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 32 , 9 , 5, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 32 , 5 , 7, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 32 , 8 , 5, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 32 , 10 , 4, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 32 , 7 , 6, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 32 , 10 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 32 , 6 , 3, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 96 , 3 , 6, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 32 , 3 , 3, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 64 , 5 , 2, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

