#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
Sun Mar 13 19:06:44 JST 2016
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;


#define	KERNEL_5	1
#define	KERNEL_18	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_13	1
#define	KERNEL_0	1
#define	KERNEL_14	1
#define	KERNEL_1	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 838 ) {
	BLK = 10;
} else
if ( n >= 838 && n < 960 ) {
	BLK = 11;
} else
if ( n >= 960 && n < 1200 ) {
	BLK = 10;
} else
if ( n >= 1200 && n < 1260 ) {
	BLK = 7;
} else
if ( n >= 1260 && n < 1440 ) {
	BLK = 5;
} else
if ( n >= 1440 && n < 1859 ) {
	BLK = 3;
} else
if ( n >= 1859 && n < 1920 ) {
	BLK = 11;
} else
if ( n >= 1920 && n < 2160 ) {
	BLK = 5;
} else
if ( n >= 2160 && n < 2400 ) {
	BLK = 2;
} else
if ( n >= 2400 && n < 2435 ) {
	BLK = 14;
} else
if ( n >= 2435 && n < 2520 ) {
	BLK = 7;
} else
if ( n >= 2520 && n < 2671 ) {
	BLK = 3;
} else
if ( n >= 2671 && n < 2880 ) {
	BLK = 5;
} else
if ( n >= 2880 && n < 3000 ) {
	BLK = 2;
} else
if ( n >= 3000 && n < 3116 ) {
	BLK = 19;
} else
if ( n >= 3116 && n < 3265 ) {
	BLK = 13;
} else
if ( n >= 3265 && n < 3600 ) {
	BLK = 2;
} else
if ( n >= 3600 && n < 3721 ) {
	BLK = 14;
} else
if ( n >= 3721 && n < 3840 ) {
	BLK = 3;
} else
if ( n >= 3840 && n < 4200 ) {
	BLK = 2;
} else
if ( n >= 4200 && n < 4224 ) {
	BLK = 13;
} else
if ( n >= 4224 && n < 4320 ) {
	BLK = 5;
} else
if ( n >= 4320 && n < 4349 ) {
	BLK = 1;
} else
if ( n >= 4349 && n < 4609 ) {
	BLK = 14;
} else
if ( n >= 4609 && n < 4800 ) {
	BLK = 2;
} else
if ( n >= 4800 && n < 5324 ) {
	BLK = 1;
} else
if ( n >= 5324 && n < 5400 ) {
	BLK = 2;
} else
if ( n >= 5400 && n < 9720 ) {
	BLK = 1;
} else
if ( n >= 9720 && n < 9839 ) {
	BLK = 18;
} else
if ( n >= 9839 && n < 9900 ) {
	BLK = 1;
} else
if ( n >= 9900 && n < 9954 ) {
	BLK = 18;
} else
if ( n >= 9954 && n < 9990 ) {
	BLK = 1;
} else
if ( n >= 9990 && n < 24525 ) {
	BLK = 18;
} else
if ( n >= 24525 && n < 24570 ) {
	BLK = 0;
} else
if ( n >= 24570 && n < 24761 ) {
	BLK = 18;
} else
if ( n >= 24761 && n < 24840 ) {
	BLK = 0;
} else
if ( n >= 24840 && n < 25875 ) {
	BLK = 18;
} else
if ( n >= 25875 && n < 25920 ) {
	BLK = 0;
} else
if ( n >= 25920 && n < 26100 ) {
	BLK = 18;
} else
if ( n >= 26100 && n < 26190 ) {
	BLK = 0;
} else
if ( n >= 26190 && n < 26325 ) {
	BLK = 18;
} else
if ( n >= 26325 && n < 26460 ) {
	BLK = 0;
} else
if ( n >= 26460 && n < 26667 ) {
	BLK = 18;
} else
if ( n >= 26667 && n < 26730 ) {
	BLK = 0;
} else
if ( n >= 26730 && n < 27225 ) {
	BLK = 18;
} else
if ( n >= 27225 && n < 27270 ) {
	BLK = 0;
} else
if ( n >= 27270 && n < 27450 ) {
	BLK = 18;
} else
if ( n >= 27450 && n < 27540 ) {
	BLK = 0;
} else
if ( n >= 27540 && n < 27675 ) {
	BLK = 18;
} else
if ( n >= 27675 && n < 27810 ) {
	BLK = 0;
} else
if ( n >= 27810 && n < 27900 ) {
	BLK = 18;
} else
if ( n >= 27900 && n < 28080 ) {
	BLK = 0;
} else
if ( n >= 28080 && n < 28226 ) {
	BLK = 18;
} else
if ( n >= 28226 && n < 28350 ) {
	BLK = 0;
} else
if ( n >= 28350 && n < 28572 ) {
	BLK = 18;
} else
if ( n >= 28572 && n < 28620 ) {
	BLK = 0;
} else
if ( n >= 28620 && n < 28800 ) {
	BLK = 18;
} else
if ( n >= 28800 && n < 28890 ) {
	BLK = 0;
} else
if ( n >= 28890 && n < 29025 ) {
	BLK = 18;
} else
if ( n >= 29025 && n < 29160 ) {
	BLK = 0;
} else
if ( n >= 29160 && n < 29250 ) {
	BLK = 18;
} else
if ( n >= 29250 && n < 29430 ) {
	BLK = 0;
} else
if ( n >= 29430 && n < 29475 ) {
	BLK = 18;
} else
if ( n >= 29475 && n < 29700 ) {
	BLK = 0;
} else
if ( n >= 29700 && n < 29784 ) {
	BLK = 18;
} else
if ( n >= 29784 && n < 29970 ) {
	BLK = 0;
} else
if ( n >= 29970 && n < 30130 ) {
	BLK = 18;
} else
if ( n >= 30130 && n < 30240 ) {
	BLK = 0;
} else
if ( n >= 30240 && n < 30375 ) {
	BLK = 18;
} else
if ( n >= 30375 && n < 30510 ) {
	BLK = 0;
} else
if ( n >= 30510 && n < 30600 ) {
	BLK = 18;
} else
if ( n >= 30600 && n < 30780 ) {
	BLK = 0;
} else
if ( n >= 30780 && n < 30825 ) {
	BLK = 18;
} else
if ( n >= 30825 && n < 31590 ) {
	BLK = 0;
} else
if ( n >= 31590 && n < 31688 ) {
	BLK = 18;
} else
if ( n >= 31688 && n < 31860 ) {
	BLK = 0;
} else
if ( n >= 31860 && n < 31950 ) {
	BLK = 18;
} else
if ( n >= 31950 && n < 32130 ) {
	BLK = 0;
} else
if ( n >= 32130 && n < 32175 ) {
	BLK = 18;
} else
if ( n >= 32175 && n < 33210 ) {
	BLK = 0;
} else
if ( n >= 33210 && n < 33245 ) {
	BLK = 18;
} else
if ( n >= 33245 && n < 33480 ) {
	BLK = 0;
} else
if ( n >= 33480 && n < 33525 ) {
	BLK = 18;
} else
if ( n >= 33525 && n < 38120 ) {
	BLK = 0;
} else
if ( n >= 38120 && n < 100000000 ) {
	BLK = 0;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 128 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 256 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 64 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 224 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 96 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 64 , 6 , 2, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 320 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

