#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  4月 24日 金曜日 21:04:51 JST
Host on laplace.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="laplace.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_17	1
#define	KERNEL_18	1
#define	KERNEL_6	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_10	1
#define	KERNEL_1	1
#define	KERNEL_15	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 117 ) {
	BLK = 10;
} else
if ( n >= 117 && n < 170 ) {
	BLK = 15;
} else
if ( n >= 170 && n < 512 ) {
	BLK = 18;
} else
if ( n >= 512 && n < 757 ) {
	BLK = 8;
} else
if ( n >= 757 && n < 789 ) {
	BLK = 7;
} else
if ( n >= 789 && n < 960 ) {
	BLK = 17;
} else
if ( n >= 960 && n < 1024 ) {
	BLK = 18;
} else
if ( n >= 1024 && n < 1280 ) {
	BLK = 7;
} else
if ( n >= 1280 && n < 1327 ) {
	BLK = 15;
} else
if ( n >= 1327 && n < 2048 ) {
	BLK = 10;
} else
if ( n >= 2048 && n < 2130 ) {
	BLK = 2;
} else
if ( n >= 2130 && n < 2240 ) {
	BLK = 3;
} else
if ( n >= 2240 && n < 2462 ) {
	BLK = 2;
} else
if ( n >= 2462 && n < 2560 ) {
	BLK = 18;
} else
if ( n >= 2560 && n < 4729 ) {
	BLK = 2;
} else
if ( n >= 4729 && n < 4800 ) {
	BLK = 6;
} else
if ( n >= 4800 && n < 4982 ) {
	BLK = 2;
} else
if ( n >= 4982 && n < 5040 ) {
	BLK = 6;
} else
if ( n >= 5040 && n < 5075 ) {
	BLK = 1;
} else
if ( n >= 5075 && n < 5120 ) {
	BLK = 6;
} else
if ( n >= 5120 && n < 5236 ) {
	BLK = 2;
} else
if ( n >= 5236 && n < 5440 ) {
	BLK = 6;
} else
if ( n >= 5440 && n < 5561 ) {
	BLK = 2;
} else
if ( n >= 5561 && n < 5760 ) {
	BLK = 6;
} else
if ( n >= 5760 && n < 5817 ) {
	BLK = 2;
} else
if ( n >= 5817 && n < 31128 ) {
	BLK = 6;
} else
if ( n >= 31128 && n < 100000000 ) {
	BLK = 6;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 96 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 32 , 12 , 4, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 352 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 32 , 8 , 4, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 224 , 1 , 7, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 32 , 7 , 4, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 64 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

